## ros-rolling-image-publisher 3.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(image_publisher)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

find_package(OpenCV REQUIRED COMPONENTS core imgcodecs videoio)
message(STATUS "opencv version ${OpenCV_VERSION}")

ament_auto_add_library(image_publisher SHARED src/image_publisher.cpp)
target_link_libraries(image_publisher ${OpenCV_LIBRARIES})
rclcpp_components_register_nodes(image_publisher "${PROJECT_NAME}::ImagePublisher")
set(node_plugins "${node_plugins}${PROJECT_NAME}::ImagePublisher;$<TARGET_FILE:ImagePublisher>\n")

ament_auto_add_executable(image_publisher_node src/image_publisher_node.cpp)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_auto_package(INSTALL_TO_SHARE launch)

## ros-rolling-image-publisher 2.2.1

=== debian/changelog ===
ros-rolling-image-publisher (2.2.1-2focal) focal; urgency=high

  * remove email blasts from steve macenski (#596 <https://github.com/ros-perception/image_pipeline/issues/596>)
  * [Foxy][Image Publisher] Update launch file (#579 <https://github.com/ros-perception/image_pipeline/issues/579>)
    Co-authored-by: louis <mailto:louis.tran@otsaw.com>
  * [Foxy] Use ament_auto Macros (#573 <https://github.com/ros-perception/image_pipeline/issues/573>)
    * Fixing version and maintainer problems in camera_calibration.
    * Applying ament_auto macros to depth_image_proc.
    * Cleaning up package.xml in image_pipeline.
    * Applying ament_auto macros to image_proc.
    * Applying ament_auto macros to image_publisher.
    * Applying ament_auto macros to image_rotate.
    * Applying ament_auto macros to image_view.
    * Replacing some deprecated headers in image_view.
    * Fixing some build warnings in image_view.
    * Applying ament_auto macros to stereo_image_proc.
    * Adding some linter tests to image_pipeline.
    * Updating package URLs to point to ROS Index.
  * Contributors: Joshua Whitley, Steve Macenski, trthanhquang

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 27 Aug 2020 07:00:00 -0000

ros-rolling-image-publisher (2.2.0-2focal) focal; urgency=high

  * Replacing deprecated header includes with new HPP versions. (#566 <https://github.com/ros-perception/image_pipeline/issues/566>)
    * Replacing deprecated header includes with new HPP versions.
    * CI: Switching to official Foxy Docker container.
    * Fixing headers which don't work correctly.
  * Opencv 3 compatibility (#564 <https://github.com/ros-perception/image_pipeline/issues/564>)
    * Remove GTK from image_view.
    It is no longer used at all in image_view.
    * Reinstate OpenCV 3 compatibility.
    While Foxy only supports Ubuntu 20.04 (and hence OpenCV 4),
    we still strive to maintain Ubuntu 18.04 (which has OpenCV 3).
    In this case, it is trivial to keep keep image_pipeline working
    with OpenCV 3, so reintroduce compatibility with it.
    * Fixes from review.
    * One more fix.
  * Use newer 'add_on_set_parameters_callback' API (#562 <https://github.com/ros-perception/image_pipeline/issues/562>)
    The old API was deprecated in Foxy and since removed in https://github.com/ros2/rclcpp/pull/1199.
  * Remove redundant install call in CMakeLists.txt (#555 <https://github.com/ros-perception/image_pipeline/issues/555>)
  * Contributors: Chris Lalancette, Jacob Perron, Joshua Whitley, sgvandijk

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 27 Jul 2020 07:00:00 -0000

ros-rolling-image-publisher (2.0.0-2focal) focal; urgency=high

  * port image_publisher on ROS2 (#366 <https://github.com/ros-perception/image_pipeline/issues/366>)
  * Initial ROS2 commit.
  * Contributors: Chris Ye, Michael Carroll

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 09 Dec 2018 08:00:00 -0000

ros-rolling-image-publisher (1.12.23-2focal) focal; urgency=high

  * fix 'VideoCapture' undefined symbol error (#318 <https://github.com/ros-perception/image_pipeline/issues/318>)
    * fix 'VideoCapture' undefined symbol error
    The following error occured when trying to run image_publisher:
    [...]/devel/lib/image_publisher/image_publisher: symbol lookup error: [...]/devel/lib//libimage_publisher.so: undefined symbol: _ZN2cv12VideoCaptureC1Ev
    Probably, changes in cv_bridge reducing the OpenCV component dependencies led to the error. See
    https://github.com/ros-perception/vision_opencv/commit/8b5bbcbc1ce65734dc600695487909e0c67c1033
    This is fixed by manually finding OpenCV with the required components and adding the dependencies to the library, not just the node.
    * add image_publisher opencv 2 compatibility
  * Contributors: hannometer

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 10 May 2018 07:00:00 -0000

ros-rolling-image-publisher (1.12.22-2focal) focal; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 08 Dec 2017 08:00:00 -0000

ros-rolling-image-publisher (1.12.21-2focal) focal; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 05 Nov 2017 07:00:00 -0000

ros-rolling-image-publisher (1.12.20-2focal) focal; urgency=high

  * explicitly cast to std::vector<double> to make gcc6 happy
    With gcc6, compiling image_publisher fails with this error:
    ```
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp:180:43: error: ambiguous overload for 'operator=' (operand types are 'sensor_msgs::CameraInfo\_<std::allocator<void> >::_D_type {aka std::vector<double>}' and 'boost::assign_detail::generic_list<int>')
    camera_info\_.D = list_of(0)(0)(0)(0)(0);
    ```
    After adding an initial explicit type cast for the assignment,
    compiling fails further with:
    ```
    | /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':
    | /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp:180:65: error: call of overloaded 'vector(boost::assign_detail::generic_list<int>&)' is ambiguous
    |      camera_info\_.D = std::vector<double> (list_of(0)(0)(0)(0)(0));
    ```
    Various sources on the internet [1, 2, 3] point to use the
    convert_to_container method; hence, this commit follows those
    suggestions and with that image_publisher compiles with gcc6.
    [1] http://stackoverflow.com/questions/16211410/ambiguity-when-using-boostassignlist-of-to-construct-a-stdvector
    [2] http://stackoverflow.com/questions/12352692/ambiguous-call-with-list-of-in-vs2010/12362548#12362548 <https://github.com/ambiguous-call-with-list-of-in-vs2010/12362548/issues/12362548>
    [3] http://stackoverflow.com/questions/13285272/using-boostassignlist-of?rq=1


=== debian/control ===
Source: ros-rolling-image-publisher
Section: misc
Priority: optional
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-auto, ros-rolling-ament-lint-auto, ros-rolling-ament-lint-common, ros-rolling-camera-info-manager, ros-rolling-class-loader, ros-rolling-cv-bridge, ros-rolling-image-geometry, ros-rolling-image-transport, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-ros-workspace
Homepage: https://index.ros.org/p/image_publisher/github-ros-perception-image_pipeline/
Standards-Version: 3.9.2

Package: ros-rolling-image-publisher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-camera-info-manager, ros-rolling-class-loader, ros-rolling-cv-bridge, ros-rolling-image-geometry, ros-rolling-image-transport, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-ros-workspace
Description: Contains a node publish an image stream from single image file or avi motion file.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-image-publisher//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-image-publisher 3.0.1

=== debian/changelog ===
ros-rolling-image-publisher (3.0.1-2jammy) jammy; urgency=high

  * Replace deprecated headers
    Fixing compiler warnings.
  * Contributors: Jacob Perron

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 04 Dec 2022 08:00:00 -0000

ros-rolling-image-publisher (3.0.0-2jammy) jammy; urgency=high

  * Cleanup image_publisher.
  * image_publisher: Fix out_img timestamp for using with sim time (#735 <https://github.com/ros-perception/image_pipeline/issues/735>)
  * Add retry video capture feature with timeout
  * changes per comments
  * fix for stereo_image_proc_tests
  * Add maintainer (#667 <https://github.com/ros-perception/image_pipeline/issues/667>)
  * Contributors: Ashwin Sushil, Chris Lalancette, Jacob Perron, Nikita Stolyarov, Patrick Musau

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 29 Apr 2022 07:00:00 -0000

ros-rolling-image-publisher (2.2.1-2jammy) jammy; urgency=high

  * remove email blasts from steve macenski (#596 <https://github.com/ros-perception/image_pipeline/issues/596>)
  * [Foxy][Image Publisher] Update launch file (#579 <https://github.com/ros-perception/image_pipeline/issues/579>)
    Co-authored-by: louis <mailto:louis.tran@otsaw.com>
  * [Foxy] Use ament_auto Macros (#573 <https://github.com/ros-perception/image_pipeline/issues/573>)
    * Fixing version and maintainer problems in camera_calibration.
    * Applying ament_auto macros to depth_image_proc.
    * Cleaning up package.xml in image_pipeline.
    * Applying ament_auto macros to image_proc.
    * Applying ament_auto macros to image_publisher.
    * Applying ament_auto macros to image_rotate.
    * Applying ament_auto macros to image_view.
    * Replacing some deprecated headers in image_view.
    * Fixing some build warnings in image_view.
    * Applying ament_auto macros to stereo_image_proc.
    * Adding some linter tests to image_pipeline.
    * Updating package URLs to point to ROS Index.
  * Contributors: Joshua Whitley, Steve Macenski, trthanhquang

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 27 Aug 2020 07:00:00 -0000

ros-rolling-image-publisher (2.2.0-2jammy) jammy; urgency=high

  * Replacing deprecated header includes with new HPP versions. (#566 <https://github.com/ros-perception/image_pipeline/issues/566>)
    * Replacing deprecated header includes with new HPP versions.
    * CI: Switching to official Foxy Docker container.
    * Fixing headers which don't work correctly.
  * Opencv 3 compatibility (#564 <https://github.com/ros-perception/image_pipeline/issues/564>)
    * Remove GTK from image_view.
    It is no longer used at all in image_view.
    * Reinstate OpenCV 3 compatibility.
    While Foxy only supports Ubuntu 20.04 (and hence OpenCV 4),
    we still strive to maintain Ubuntu 18.04 (which has OpenCV 3).
    In this case, it is trivial to keep keep image_pipeline working
    with OpenCV 3, so reintroduce compatibility with it.
    * Fixes from review.
    * One more fix.
  * Use newer 'add_on_set_parameters_callback' API (#562 <https://github.com/ros-perception/image_pipeline/issues/562>)
    The old API was deprecated in Foxy and since removed in https://github.com/ros2/rclcpp/pull/1199.
  * Remove redundant install call in CMakeLists.txt (#555 <https://github.com/ros-perception/image_pipeline/issues/555>)
  * Contributors: Chris Lalancette, Jacob Perron, Joshua Whitley, sgvandijk

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Mon, 27 Jul 2020 07:00:00 -0000

ros-rolling-image-publisher (2.0.0-2jammy) jammy; urgency=high

  * port image_publisher on ROS2 (#366 <https://github.com/ros-perception/image_pipeline/issues/366>)
  * Initial ROS2 commit.
  * Contributors: Chris Ye, Michael Carroll

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 09 Dec 2018 08:00:00 -0000

ros-rolling-image-publisher (1.12.23-2jammy) jammy; urgency=high

  * fix 'VideoCapture' undefined symbol error (#318 <https://github.com/ros-perception/image_pipeline/issues/318>)
    * fix 'VideoCapture' undefined symbol error
    The following error occured when trying to run image_publisher:
    [...]/devel/lib/image_publisher/image_publisher: symbol lookup error: [...]/devel/lib//libimage_publisher.so: undefined symbol: _ZN2cv12VideoCaptureC1Ev
    Probably, changes in cv_bridge reducing the OpenCV component dependencies led to the error. See
    https://github.com/ros-perception/vision_opencv/commit/8b5bbcbc1ce65734dc600695487909e0c67c1033
    This is fixed by manually finding OpenCV with the required components and adding the dependencies to the library, not just the node.
    * add image_publisher opencv 2 compatibility
  * Contributors: hannometer

 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Thu, 10 May 2018 07:00:00 -0000

ros-rolling-image-publisher (1.12.22-2jammy) jammy; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Fri, 08 Dec 2017 08:00:00 -0000

ros-rolling-image-publisher (1.12.21-2jammy) jammy; urgency=high



 -- Vincent Rabaud <vincent.rabaud@gmail.com>  Sun, 05 Nov 2017 07:00:00 -0000

ros-rolling-image-publisher (1.12.20-2jammy) jammy; urgency=high

  * explicitly cast to std::vector<double> to make gcc6 happy
    With gcc6, compiling image_publisher fails with this error:
    ```
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':
    /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp:180:43: error: ambiguous overload for 'operator=' (operand types are 'sensor_msgs::CameraInfo\_<std::allocator<void> >::_D_type {aka std::vector<double>}' and 'boost::assign_detail::generic_list<int>')
    camera_info\_.D = list_of(0)(0)(0)(0)(0);
    ```
    After adding an initial explicit type cast for the assignment,
    compiling fails further with:
    ```
    | /[...]/image_publisher/src/nodelet/image_publisher_nodelet.cpp: In member function 'virtual void image_publisher::ImagePublisherNodelet::onInit()':


=== debian/control ===
Source: ros-rolling-image-publisher
Section: misc
Priority: optional
Maintainer: Vincent Rabaud <vincent.rabaud@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-auto, ros-rolling-ament-lint-auto <!nocheck>, ros-rolling-ament-lint-common <!nocheck>, ros-rolling-camera-info-manager, ros-rolling-cv-bridge, ros-rolling-image-transport, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-ros-workspace
Homepage: https://index.ros.org/p/image_publisher/github-ros-perception-image_pipeline/
Standards-Version: 3.9.2

Package: ros-rolling-image-publisher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-camera-info-manager, ros-rolling-cv-bridge, ros-rolling-image-transport, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-ros-workspace
Description: Contains a node publish an image stream from single image file or avi motion file.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
